package ;

import nme.events.Event;
import nme.JNI;
import nme.Lib;
import nme.media.Sound;
import nme.media.SoundChannel;
import nme.media.SoundTransform;

/**
 * ...
 * @author brad
 */

class MusicOffsetLoop 
{

	private static var jni_play:Dynamic;
	private static var jni_get_sound_handle:Dynamic;
	private static var jni_resume:Dynamic;
	private static var jni_pause:Dynamic;
	
	
	
	public static function play( sound:Sound, repeatOffset:Float ) {
		if ( jni_play == null ) {
			jni_play = JNI.createStaticMethod( "MusicOffsetLoop", "playMusic", "(ID)I");
			setStageEventListeners();
		}
		// I set sound.url in Sound.hx.. That should go into IRL NME
		trace("Trying to get sound id for: " + sound.url );
		
		if ( jni_get_sound_handle == null )
			jni_get_sound_handle = JNI.createStaticMethod( "org/haxe/nme/GameActivity", "getMusicHandle", "(Ljava/lang/String;)I");
		
		trace( "sending " + sound.url + " to " + jni_get_sound_handle );
		var sID = jni_get_sound_handle( sound.url );
		
		trace('sid is ' + sID );
		
		jni_play( sID, repeatOffset );
		
	}
	
	private static function pause() {
		if ( jni_pause == null )
			jni_pause = JNI.createStaticMethod( "MusicOffsetLoop", "pause", "()V" );
		jni_pause();
	}
	
	private static function resume() {
		if ( jni_resume == null )
			jni_resume = JNI.createStaticMethod( "MusicOffsetLoop", "resume", "()V" );
		jni_resume();
	}
	
	
	private static function setStageEventListeners() {
		Lib.current.stage.addEventListener( Event.ACTIVATE, function(e:Event) { resume(); } ); 
		Lib.current.stage.addEventListener( Event.DEACTIVATE, function(e:Event) { pause(); } ); 		
	}
	
}